%include "src/asm_io.inc"

section .data
    prompt_array db "Enter numbers (one by one): ", 0
    prompt_size db "Enter size of the array: ", 0
    max_msg db "Maximum value is: ", 0
    min_msg db "Minimum value is: ", 0
    sum_msg db "Sum of all values is: ", 0
    newline db 10, 0

section .bss
    array resd 100      ; Reserve space for an array of 100 integers
    size resd 1         ; Store the size of the array
    max_val resd 1      ; Store the maximum value
    min_val resd 1      ; Store the minimum value
    total resd 1        ; Store the sum of the array elements

section .text
    global _asm_main

_asm_main:
    ; Prompt user for array size
    mov eax, prompt_size
    call print_string
    call read_int
    mov [size], eax

    ; Fill the array
    mov ecx, [size]
    xor edi, edi        ; Index for the array
fill_array:
    mov eax, prompt_array
    call print_string
    call read_int       ; Read one integer
    mov [array + edi * 4], eax
    inc edi
    loop fill_array

    ; Find maximum and minimum values
    call find_max_min

    ; Calculate the sum of the array
    call calculate_sum

    ; Print results
    mov eax, max_msg
    call print_string
    mov eax, [max_val]
    call print_int
    call print_nl

    mov eax, min_msg
    call print_string
    mov eax, [min_val]
    call print_int
    call print_nl

    mov eax, sum_msg
    call print_string
    mov eax, [total]
    call print_int
    call print_nl
    ret

find_max_min:
    mov ecx, [size]
    mov edi, 0
    mov eax, [array]    ; Load the first element
    mov ebx, eax        ; Assume it is the maximum
    mov edx, eax        ; Assume it is the minimum
find_loop:
    mov eax, [array + edi * 4]
    cmp eax, ebx
    jle check_min
    mov ebx, eax        ; Update maximum
check_min:
    cmp eax, edx
    jge next
    mov edx, eax        ; Update minimum
next:
    inc edi
    loop find_loop
    mov [max_val], ebx
    mov [min_val], edx
    ret

calculate_sum:
    mov ecx, [size]
    mov edi, 0
    xor eax, eax        ; Initialize sum to 0
sum_loop:
    add eax, [array + edi * 4]
    inc edi
    loop sum_loop
    mov [total], eax
    ret   
section .note.GNU-stack noalloc noexec nowrite progbits


